#include <sys/param.h>
#include <sys/kernel.h>
#include <sys/module.h>
#include <sys/sysctl.h>
#include <sys/systm.h>
#include <sys/proc.h>
#include <sys/kthread.h>

#include <vm/vm.h>
#include <vm/pmap.h>

#include <x86/apicreg.h>

#include <machine/vmparam.h>
#include <machine/pmap.h>

void docmp(int *val1, int *val2, uint16_t x, uint16_t *ptr);

SYSCTL_NODE(_debug, OID_AUTO, instlen, CTLFLAG_RW, 0, NULL);

static u_long cmpaddr;
SYSCTL_ULONG(_debug_instlen, OID_AUTO, cmpaddr, CTLFLAG_RW, &cmpaddr, 0, NULL);

static int eq;
SYSCTL_INT(_debug_instlen, OID_AUTO, eq, CTLFLAG_RW, &eq, 0, NULL);

static int ne;
SYSCTL_INT(_debug_instlen, OID_AUTO, ne, CTLFLAG_RW, &ne, 0, NULL);

static int cmpval;
SYSCTL_INT(_debug_instlen, OID_AUTO, cmpval, CTLFLAG_RW, &cmpval, 0, NULL);

static int
sysctl_doit(SYSCTL_HANDLER_ARGS)
{
	int error, doit;

	doit = 0;
	error = sysctl_handle_int(oidp, &doit, 0, req);
	if (error || req->newptr == NULL || doit == 0)
		return (error);

	if (cmpaddr == 0) {
		printf("debug.instlen.cmpaddr not initialized!\n");
		return (EINVAL);
	}

	docmp(&eq, &ne, cmpval, (uint16_t *)(uintptr_t)PHYS_TO_DMAP(cmpaddr));

	return (0);
}

SYSCTL_PROC(_debug_instlen, OID_AUTO, doit, CTLTYPE_INT|CTLFLAG_RW, 0, 0, 
    sysctl_doit, "I", "");

static int
instlen_modevent(module_t mod, int type, void *unused)
{

        switch (type) {
        case MOD_LOAD:
		break;
	case MOD_UNLOAD:
		break;
	default:
		return (EINVAL);
	}

	return (0);
}

static moduledata_t instlen_mod_data= {
	"instlen",
	instlen_modevent,
};

DECLARE_MODULE(test, instlen_mod_data, SI_SUB_SMP + 1, SI_ORDER_ANY);
